searchNodes=[{"doc":"Find and use UARTs, serial ports, and more.","ref":"Circuits.UART.html","title":"Circuits.UART","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Circuits.UART.html#child_spec/1","title":"Circuits.UART.child_spec/1","type":"function"},{"doc":"Close the serial port. The GenServer continues to run so that a port can be opened again.","ref":"Circuits.UART.html#close/1","title":"Circuits.UART.close/1","type":"function"},{"doc":"Get the configuration of the serial port.","ref":"Circuits.UART.html#configuration/1","title":"Circuits.UART.configuration/1","type":"function"},{"doc":"Change the serial port configuration after open/3 has been called. See open/3 for the valid options.","ref":"Circuits.UART.html#configure/2","title":"Circuits.UART.configure/2","type":"function"},{"doc":"Change the controlling process that receives events from an active uart.","ref":"Circuits.UART.html#controlling_process/2","title":"Circuits.UART.controlling_process/2","type":"function"},{"doc":"Waits until all data has been transmitted. See tcdrain(3) for low level details on Linux or OSX. This is not implemented on Windows.","ref":"Circuits.UART.html#drain/1","title":"Circuits.UART.drain/1","type":"function"},{"doc":"Return a map of available ports with information about each one. The map looks like this: %{ &quot;ttyS0&quot; -&gt; %{vendor_id: 1234, product_id: 1, manufacturer: &quot;Acme Corporation&quot;, serial_number: &quot;000001&quot;}, &quot;ttyUSB0&quot; -&gt; ${vendor_id: 1234, product_id: 2} } Depending on the port and the operating system, not all fields may be returned. Informational fields are: :vendor_id - The 16-bit USB vendor ID of the device providing the port. Vendor ID to name lists are managed through usb.org :product_id - The 16-bit vendor supplied product ID :manufacturer - The manufacturer of the port :description - A description or product name :serial_number - The device&#39;s serial number if it has one","ref":"Circuits.UART.html#enumerate/0","title":"Circuits.UART.enumerate/0","type":"function"},{"doc":"Find UARTs. This is intended as a diagnostic function for finding UARTs that you may have opened and forgotten about. Since a UART can only be opened once, this helps you find the problematic one so that you can close it. It returns a list of {pid, uart_name} tuples. NOTE: Do not rely on this function in production code. It may change if updates to the interface make it more convenient to use.","ref":"Circuits.UART.html#find_pids/0","title":"Circuits.UART.find_pids/0","type":"function"},{"doc":"Flushes the :receive buffer, the :transmit buffer, or :both. See tcflush(3) for low level details on Linux or OSX. This calls PurgeComm on Windows.","ref":"Circuits.UART.html#flush/2","title":"Circuits.UART.flush/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Circuits.UART.html#init/1","title":"Circuits.UART.init/1","type":"function"},{"doc":"Open a serial port. The following options are available: :active - (true or false) specifies whether data is received as messages or by calling read/2. See discussion below. :speed - (number) set the initial baudrate (e.g., 115200) :data_bits - (5, 6, 7, 8) set the number of data bits (usually 8) :stop_bits - (1, 2) set the number of stop bits (usually 1) :parity - (:none, :even, :odd, :space, or :mark) set the parity. Usually this is :none. Other values: :space means that the parity bit is always 0 :mark means that the parity bit is always 1 :ignore means that the parity bit is ignored (Linux/OSX only) :flow_control - (:none, :hardware, or :software) set the flow control strategy. :framing - (module or {module, args}) set the framing for data. The module must implement the Circuits.UART.Framing behaviour. See Circuits.UART.Framing.None, Circuits.UART.Framing.Line, and Circuits.UART.Framing.FourByte. The default is Circuits.UART.Framing.None. :rx_framing_timeout - (milliseconds) this specifies how long incomplete frames will wait for the remainder to be received. Timed out partial frames are reported as {:partial, data}. A timeout of &lt;= 0 means to wait forever. :id - (:name or :pid) specify what to return with the uart active messages. with :name the messages are returned as {:circuits_uart, serial_port_name, data} otherwise they are returned as {:circuits_uart, pid, data}. The name and pid are the name of the connected UART or the pid of the Circuits.UART server pid as returned by start_link/1. The default value is :name. Active mode defaults to true and means that data received on the UART is reported in messages. The messages have the following form: {:circuits_uart, serial_port_id, data} or {:circuits_uart, serial_port_id, {:error, reason}} When in active mode, flow control can not be used to push back on the sender and messages will accumulated in the mailbox should data arrive fast enough. If this is an issue, set :active to false and call read/2 manually when ready for more data. On success, open/3 returns :ok. On error, {:error, reason} is returned. The following are some reasons: :enoent - the specified port couldn&#39;t be found :eagain - the port is already open :eacces - permission was denied when opening the port","ref":"Circuits.UART.html#open/3","title":"Circuits.UART.open/3","type":"function"},{"doc":"Read data from the UART. This call returns data as soon as it&#39;s available or after timing out. Returns {:ok, binary}, where binary is a binary data object that contains the read data, or {:error, reason} if an error occurs. Typical error reasons: :ebadf - the UART is closed :einval - the UART is in active mode","ref":"Circuits.UART.html#read/2","title":"Circuits.UART.read/2","type":"function"},{"doc":"Send a continuous stream of zero bits for a duration in milliseconds. By default, the zero bits are transmitted at least 0.25 seconds. This is a convenience function for calling set_break/2 to enable the break signal, wait, and then turn it off.","ref":"Circuits.UART.html#send_break/2","title":"Circuits.UART.send_break/2","type":"function"},{"doc":"Start or stop sending a break signal.","ref":"Circuits.UART.html#set_break/2","title":"Circuits.UART.set_break/2","type":"function"},{"doc":"Set or clear the Data Terminal Ready signal.","ref":"Circuits.UART.html#set_dtr/2","title":"Circuits.UART.set_dtr/2","type":"function"},{"doc":"Set or clear the Request To Send signal.","ref":"Circuits.UART.html#set_rts/2","title":"Circuits.UART.set_rts/2","type":"function"},{"doc":"Returns a map of signal names and their current state (true or false). Signals include: :dsr - Data Set Ready :dtr - Data Terminal Ready :rts - Request To Send :st - Secondary Transmitted Data :sr - Secondary Received Data :cts - Clear To Send :cd - Data Carrier Detect :rng - Ring Indicator","ref":"Circuits.UART.html#signals/1","title":"Circuits.UART.signals/1","type":"function"},{"doc":"Start up a UART GenServer.","ref":"Circuits.UART.html#start_link/1","title":"Circuits.UART.start_link/1","type":"function"},{"doc":"Stop the UART GenServer.","ref":"Circuits.UART.html#stop/1","title":"Circuits.UART.stop/1","type":"function"},{"doc":"Write data to the opened UART. It&#39;s possible for the write to return before all of the data is actually transmitted. To wait for the data, call drain/1. This call blocks until all of the data to be written is in the operating system&#39;s internal buffers. If you&#39;re sending a lot of data on a slow link, supply a longer timeout to avoid timing out prematurely. Returns :ok on success or {:error, reason} if an error occurs. Typical error reasons: :ebadf - the UART is closed","ref":"Circuits.UART.html#write/3","title":"Circuits.UART.write/3","type":"function"},{"doc":"","ref":"Circuits.UART.html#t:uart_option/0","title":"Circuits.UART.uart_option/0","type":"type"},{"doc":"A behaviour for implementing framers for data received over a UART.","ref":"Circuits.UART.Framing.html","title":"Circuits.UART.Framing","type":"behaviour"},{"doc":"Add framing to the passed in data. The returned frame_data will be sent out the UART.","ref":"Circuits.UART.Framing.html#c:add_framing/2","title":"Circuits.UART.Framing.add_framing/2","type":"callback"},{"doc":"This is called when the user invokes Circuits.UART.flush/2. Any partially received frames should be dropped.","ref":"Circuits.UART.Framing.html#c:flush/2","title":"Circuits.UART.Framing.flush/2","type":"callback"},{"doc":"If remove_framing/2 returned :in_frame and a user-specified timeout for reassembling frames has elapsed, then this function is called. Depending on the semantics of the framing, a partial frame may be returned or the incomplete frame may be dropped.","ref":"Circuits.UART.Framing.html#c:frame_timeout/1","title":"Circuits.UART.Framing.frame_timeout/1","type":"callback"},{"doc":"Initialize the state of the framer based on options passed to Circuits.UART.open/3. This function should return the initial state for the framer or an error.","ref":"Circuits.UART.Framing.html#c:init/1","title":"Circuits.UART.Framing.init/1","type":"callback"},{"doc":"Remove the framing off received data. If a partial frame is left over at the end, then :in_frame should be returned. All of the frames received should be returned in the second tuple. The terms returned as the second part of the tuple can be anything. They can be the binary messages without the framing, structs based on your commands, or anything else. If you have errors in the protocol, for example a bad checksum, one convention is to return an error tuple {:error, :echksum, message}. For debugging you may want to include the message and framing with the error for simpler debugging.","ref":"Circuits.UART.Framing.html#c:remove_framing/2","title":"Circuits.UART.Framing.remove_framing/2","type":"callback"},{"doc":"Each message is 4 bytes. This framer doesn&#39;t do anything for the transmit direction, but for receives, it will collect bytes in batches of 4 before sending them up. The user can set up a framer timeout if they don&#39;t mind partial frames. This can be useful to resyncronize when bytes are dropped.","ref":"Circuits.UART.Framing.FourByte.html","title":"Circuits.UART.Framing.FourByte","type":"module"},{"doc":"Callback implementation for Circuits.UART.Framing.add_framing/2.","ref":"Circuits.UART.Framing.FourByte.html#add_framing/2","title":"Circuits.UART.Framing.FourByte.add_framing/2","type":"function"},{"doc":"Callback implementation for Circuits.UART.Framing.flush/2.","ref":"Circuits.UART.Framing.FourByte.html#flush/2","title":"Circuits.UART.Framing.FourByte.flush/2","type":"function"},{"doc":"Callback implementation for Circuits.UART.Framing.frame_timeout/1.","ref":"Circuits.UART.Framing.FourByte.html#frame_timeout/1","title":"Circuits.UART.Framing.FourByte.frame_timeout/1","type":"function"},{"doc":"Callback implementation for Circuits.UART.Framing.init/1.","ref":"Circuits.UART.Framing.FourByte.html#init/1","title":"Circuits.UART.Framing.FourByte.init/1","type":"function"},{"doc":"Callback implementation for Circuits.UART.Framing.remove_framing/2.","ref":"Circuits.UART.Framing.FourByte.html#remove_framing/2","title":"Circuits.UART.Framing.FourByte.remove_framing/2","type":"function"},{"doc":"Each message is one line. This framer appends and removes newline sequences as part of the framing. Buffering is performed internally, so users can get the complete messages under normal circumstances. Attention should be paid to the following: Lines must have a fixed max length so that a misbehaving sender can&#39;t cause unbounded buffer expansion. When the max length is passed, a {:partial, data} is reported. The application can decide what to do with this. The separation character varies depending on the target device. See &quot;Separator&quot; section to see how to specify this. It may be desirable to set a :rx_framer_timeout to prevent characters received in error from collecting during idle times. When the receive timer expires, {:partial, data} is reported. Line separators must be ASCII characters (0-127) or be valid UTF-8 sequences. If the device only sends ASCII, high characters (128-255) should work as well. [Note: please report if using extended characters.] Separator Some devices require &quot;\\r\\n&quot; sequences. If you are using one of these devices, a LTE modem for example, you can specify the separator like so: Circuits.UART.open(uart, tty_name, framing: {Line, separator: &quot;\\r\\n&quot;}) By default the separator is &quot;\\n&quot;. Currently only one or two character separators are supported.","ref":"Circuits.UART.Framing.Line.html","title":"Circuits.UART.Framing.Line","type":"module"},{"doc":"Callback implementation for Circuits.UART.Framing.add_framing/2.","ref":"Circuits.UART.Framing.Line.html#add_framing/2","title":"Circuits.UART.Framing.Line.add_framing/2","type":"function"},{"doc":"","ref":"Circuits.UART.Framing.Line.html#buffer_empty?/1","title":"Circuits.UART.Framing.Line.buffer_empty?/1","type":"function"},{"doc":"Callback implementation for Circuits.UART.Framing.flush/2.","ref":"Circuits.UART.Framing.Line.html#flush/2","title":"Circuits.UART.Framing.Line.flush/2","type":"function"},{"doc":"Callback implementation for Circuits.UART.Framing.frame_timeout/1.","ref":"Circuits.UART.Framing.Line.html#frame_timeout/1","title":"Circuits.UART.Framing.Line.frame_timeout/1","type":"function"},{"doc":"Callback implementation for Circuits.UART.Framing.init/1.","ref":"Circuits.UART.Framing.Line.html#init/1","title":"Circuits.UART.Framing.Line.init/1","type":"function"},{"doc":"Callback implementation for Circuits.UART.Framing.remove_framing/2.","ref":"Circuits.UART.Framing.Line.html#remove_framing/2","title":"Circuits.UART.Framing.Line.remove_framing/2","type":"function"},{"doc":"Don&#39;t apply or removing any framing.","ref":"Circuits.UART.Framing.None.html","title":"Circuits.UART.Framing.None","type":"module"},{"doc":"Callback implementation for Circuits.UART.Framing.add_framing/2.","ref":"Circuits.UART.Framing.None.html#add_framing/2","title":"Circuits.UART.Framing.None.add_framing/2","type":"function"},{"doc":"Callback implementation for Circuits.UART.Framing.flush/2.","ref":"Circuits.UART.Framing.None.html#flush/2","title":"Circuits.UART.Framing.None.flush/2","type":"function"},{"doc":"Callback implementation for Circuits.UART.Framing.frame_timeout/1.","ref":"Circuits.UART.Framing.None.html#frame_timeout/1","title":"Circuits.UART.Framing.None.frame_timeout/1","type":"function"},{"doc":"Callback implementation for Circuits.UART.Framing.init/1.","ref":"Circuits.UART.Framing.None.html#init/1","title":"Circuits.UART.Framing.None.init/1","type":"function"},{"doc":"Callback implementation for Circuits.UART.Framing.remove_framing/2.","ref":"Circuits.UART.Framing.None.html#remove_framing/2","title":"Circuits.UART.Framing.None.remove_framing/2","type":"function"},{"doc":"Circuits.UART Circuits.UART allows you to use UARTs, serial ports, Bluetooth virtual serial port connections and more in Elixir. Some highlights: Mac, Windows, Linux, and Nerves Enumerate serial ports Receive input via messages or by polling (active and passive modes) Add and remove framing on serial data - line-based framing included for use with GPS, cellular, satellite and other modules Unit tests (uses the tty0tty virtual null modem on Travis) Looking for Nerves.UART? Circuits.UART is the new name. Everything else is the same. Update your project by replacing all references to nerves_uart and Nerves.UART to circuits_uart and Circuits.UART and you should be good. Something doesn&#39;t work for you? Check out below and the docs. Post a question on the Elixir Forum or file an issue or PR.","ref":"readme.html","title":"Circuits.UART","type":"extras"},{"doc":"Discover what serial ports are attached: iex&gt; Circuits.UART.enumerate %{&quot;COM14&quot; =&gt; %{description: &quot;USB Serial Port&quot;, manufacturer: &quot;FTDI&quot;, product_id: 24577, vendor_id: 1027}, &quot;COM5&quot; =&gt; %{description: &quot;Prolific USB-to-Serial Comm Port&quot;, manufacturer: &quot;Prolific&quot;, product_id: 8963, vendor_id: 1659}, &quot;COM16&quot; =&gt; %{description: &quot;Arduino Uno&quot;, manufacturer: &quot;Arduino LLC (www.arduino.cc)&quot;, product_id: 67, vendor_id: 9025}} Start the UART GenServer: iex&gt; {:ok, pid} = Circuits.UART.start_link {:ok, #PID&lt;0.132.0&gt;} The GenServer doesn&#39;t open a port automatically, so open up a serial port or UART now. See the results from your call to Circuits.UART.enumerate/0 for what&#39;s available on your system. iex&gt; Circuits.UART.open(pid, &quot;COM14&quot;, speed: 115200, active: false) :ok This opens the serial port up at 115200 baud and turns off active mode. This means that you&#39;ll have to manually call Circuits.UART.read to receive input. In active mode, input from the serial port will be sent as messages. See the docs for all options. Write something to the serial port: iex&gt; Circuits.UART.write(pid, &quot;Hello there\\r\\n&quot;) :ok See if anyone responds in the next 60 seconds: iex&gt; Circuits.UART.read(pid, 60000) {:ok, &quot;Hi&quot;} Input is reported as soon as it is received, so you may need multiple calls to read/2 to get everything you want. If you have flow control enabled and stop calling read/2, the port will push back to the sender when its buffers fill up. Enough with passive mode, let&#39;s switch to active mode: iex&gt; Circuits.UART.configure(pid, active: true) :ok iex&gt; flush {:circuits_uart, &quot;COM14&quot;, &quot;a&quot;} {:circuits_uart, &quot;COM14&quot;, &quot;b&quot;} {:circuits_uart, &quot;COM14&quot;, &quot;c&quot;} {:circuits_uart, &quot;COM14&quot;, &quot;\\r&quot;} {:circuits_uart, &quot;COM14&quot;, &quot;\\n&quot;} :ok It turns out that COM14 is a USB to serial port. Let&#39;s unplug it and see what happens: iex&gt; flush {:circuits_uart, &quot;COM14&quot;, {:error, :eio}} Oops. Well, when it appears again, it can be reopened. In passive mode, errors get reported on the calls to Circuits.UART.read/2 and Circuits.UART.write/3 Back to receiving data, it&#39;s a little annoying that characters arrive one by one. That&#39;s because our computer is really fast compared to the serial port, but if something slows it down, we could receive two or more characters at a time. Rather than reassemble the characters into lines, we can ask circuits_uart to do it for us: iex&gt; Circuits.UART.configure(pid, framing: {Circuits.UART.Framing.Line, separator: &quot;\\r\\n&quot;}) :ok This tells circuits_uart to append a \\r\\n to each call to write/2 and to report each line separately in active and passive mode. You can set this configuration in the call to open/3 as well. Here&#39;s what we get now: iex&gt; flush {:circuits_uart, &quot;COM14&quot;, &quot;abc&quot;} # Note that the &quot;\\r\\n&quot; is trimmed :ok If your serial data is framed differently, check out the Circuits.UART.Framing behaviour and implement your own. Circuits.UART.Framing.FourByte is a particularly simple example of a framer. You can also set a timeout so that a partial line doesn&#39;t hang around in the receive buffer forever: iex&gt; Circuits.UART.configure(pid, rx_framing_timeout: 500) :ok # Assume that the sender sent the letter &quot;A&quot; without sending anything else # for 500 ms. iex&gt; flush {:circuits_uart, &quot;COM14&quot;, {:partial, &quot;A&quot;}} Sometimes it&#39;s easier to operate with the pid of the UART GenServer rather than using the name of the port in active mode. An example of this is when you want to send an acknowledgment back after a receive and you are using more than one serial port at a time. You can do this with the id: :pid option to open/1 or configure/1. iex&gt; Circuits.UART.configure(pid, id: :pid) :ok # Assume some data was received iex&gt; receive do ...&gt; {:circuits_uart, pid, _} -&gt; ...&gt; Circuits.UART.write(pid, &quot;ack&quot;) ...&gt; end :ok","ref":"readme.html#example-use","title":"Circuits.UART - Example use","type":"extras"},{"doc":"To install circuits_uart: Add circuits_uart to your list of dependencies in mix.exs: def deps do [{:circuits_uart, &quot;~&gt; 1.3&quot;}] end Check that the C compiler dependencies are satisified (see below) Run mix deps.get and mix compile C compiler dependencies Since this library includes C code, make, gcc, and Erlang header and development libraries are required. On Linux systems, this usually requires you to install the build-essential and erlang-dev packages. For example: sudo apt-get install build-essential erlang-dev On Macs, run gcc --version or make --version. If they&#39;re not installed, you will be given instructions. On Windows, if you&#39;re obtaining circuits_uart from hex.pm, you&#39;ll need MinGW to compile the C code. I use Chocolatey and install MinGW by running the following in an administrative command prompt: choco install mingw On Nerves, you&#39;re set - just add circuits_uart to your mix.exs. Nerves contains everything needed by default. If you do use Nerves, though, keep in mind that the C code is crosscompiled for your target hardware and will not work on your host (the port will crash when you call start_link or enumerate. If you want to try out circuits_uart on your host machine, the easiest way is to either clone the source or add circuits_uart as a dependency to a regular (non-Nerves) Elixir project.","ref":"readme.html#installation","title":"Circuits.UART - Installation","type":"extras"},{"doc":"The standard Elixir build process applies. Clone circuits_uart or download a source release and run: mix deps.get mix compile The unit tests require two serial ports connected via a NULL modem cable to run. Define the names of the serial ports in the environment before running the tests. For example, export CIRCUITS_UART_PORT1=ttyS0 export CIRCUITS_UART_PORT2=ttyS1 If you&#39;re on Windows or Linux, you don&#39;t need real serial ports. For linux, download and install tty0tty. Load the kernel module and specify tnt0 and tnt1 for the serial ports. Check the tty0tty README.md, but this should looks something like: cd tty0tty/module make sudo cp tty0tty.ko /lib/modules/$(uname -r)/kernel/drivers/misc/ sudo depmod sudo modprobe tty0tty sudo chmod 666 /dev/tnt* export CIRCUITS_UART_PORT1=tnt0 export CIRCUITS_UART_PORT2=tnt1 On Windows, download and install com0com (Look for version 2.2.2.0 if the latest hasn&#39;t been signed). The ports on Windows are CNCA0 and CNCB0. Then run: mix test If you&#39;re using tty0tty, the tests will run at full speed. Real serial ports seem to take a fraction of a second to close and re-open. I added a gratuitous delay to each test to work around this. It likely can be much shorter. On MacOS, download and install socat. You can install it via Homebrew. Once you have it installed and ready to go, run the following command. You will need to change &lt;USERNAME&gt; to your current system username sudo socat -d -d -d -d -lf /tmp/socat pty,link=/dev/dummy1,raw,echo=0,user=&lt;USERNAME&gt;,group=staff link=/dev/dummy2,raw,echo=0,user=&lt;USERNAME&gt;,group=staff Once that opens, in a separate terminal emulator, set the Circuits ENVars, and go about your testing export CIRCUITS_UART_PORT1=/dev/dummy1 export CIRCUITS_UART_PORT2=/dev/dummy2 mix test","ref":"readme.html#building-and-running-the-unit-tests","title":"Circuits.UART - Building and running the unit tests","type":"extras"},{"doc":"Do I have to use Nerves? No, this project doesn&#39;t have any dependencies on any Nerves components. The desire for some serial port library features on Nerves drove us to create it, but we also have host-based use cases. To be useful for us, the library must remain crossplatform and have few dependencies. We&#39;re just developing it under the Nerves umbrella. How can I use the serial port on Linux without sudo? Serial port files are almost always owned by the dialout group. Add yourself to the dialout group by running sudo adduser yourusername dialout. Then log out and back in again, and you should be able to access the serial port. Debugging tips If you&#39;re having trouble and suspect the C code, edit the Makefile to enable debug logging. See the Makefile for instructions on how to do this. Debug logging is appended to a file by default, but can be sent to stderr or another location by editing src/circuits_uart.c. If you&#39;re on Linux, the tty0tty emulated null modem removes the flakiness of real serial port drivers if that&#39;s the problem. The serial port monitor jpnevulator is useful for monitoring the hardware signals and dumping data as hex byte values. On OSX and Windows, I&#39;ve found that PL2303-based serial ports can be flakey. First, make sure that you don&#39;t have a counterfeit PL2303. On Windows, they show up in device manager with a warning symbol. On OSX, they seem to hang when closing the port. Non-counterfeit PL2303-based serial ports can pass the unit tests on Windows 10, but I have not been able to get them to pass on OSX. FTDI-based serial ports appear to work better on both operating systesm. ei_copy why???? You may have noticed Erlang&#39;s erl_interface code copy/pasted into src/ei_copy. This is only used on Windows to work around issues linking to the distributed version of erl_interface. That was compiled with Visual Studio. This project uses MinGW, and even though the C ABIs are the same between the compilers, Visual Studio adds stack protection calls that I couldn&#39;t figure out how to work around. How does Circuits.UART communicate with the serial port? Circuits.UART uses a Port and C code. Elixir/Erlang ports have nothing to do with the serial ports of the operating system. They share the same name but are different concepts.","ref":"readme.html#faq","title":"Circuits.UART - FAQ","type":"extras"},{"doc":"When building this library, node-serialport and QtSerialPort where incredibly helpful in helping to define APIs and point out subtleties with platform-specific serial port code. Sadly, I couldn&#39;t reuse their code, but I feel indebted to the authors and maintainers of these libraries, since they undoubtedly saved me hours of time debugging corner cases. I have tried to acknowledge them in the comments where I have used strategies that I learned from them.","ref":"readme.html#acknowledgments","title":"Circuits.UART - Acknowledgments","type":"extras"}]